unit PxCust1;

{
this valcheck editor was originally created by
Andreas Schiller, (CIS 100304,3535), for use
with PxValcheckTable (check the Delphi libs
for PXVALTBL.ZIP!).

changed for use with TPxValCheckRetriever by
Reinhard Kalinke
100417,3504 @compuserve.com
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBCtrls, DB, DBTables, Mask, FileCtrl,
  {$IFDEF WIN32}PxConst2, PxValRt2,{$ELSE}PxConsts, PxValRtr,{$ENDIF}
  DBITypes, ExtCtrls;

type
  TfmMain = class(TForm)
    db: TDatabase;
    lsFields: TListBox;
    lsFiles: TFileListBox;
    pnlProps: TPanel;
    edHasValchecks: TCheckBox;
    edRequired: TCheckBox;
    Label1: TLabel;
    edPicture: TEdit;
    Label2: TLabel;
    edMinValue: TEdit;
    Label3: TLabel;
    edMaxValue: TEdit;
    Label4: TLabel;
    edDefaultValue: TEdit;
    showFieldType: TComboBox;
    Label5: TLabel;
    lsDirs: TDirectoryListBox;
    Label6: TLabel;
    Label7: TLabel;
    pnlStatus: TPanel;
    Label8: TLabel;
    tmStatus: TTimer;
    DriveComboBox1: TDriveComboBox;
    Label9: TLabel;
    tblEdit: TTable;
    PxValRetriever: TPxValcheckRetriever;
    rgRetrMode: TRadioGroup;
    btnWrite: TButton;
    btnClear: TButton;
    Label10: TLabel;

    procedure FormCreate(Sender: TObject);
    procedure pnlPropsEnable(YesNo: Boolean);
    procedure lsFieldsClick(Sender: TObject);
    procedure lsDirsChange(Sender: TObject);
    procedure tblEditxAfterOpen(DataSet: TDataset);
    procedure lsFilesChange(Sender: TObject);
    procedure tblEditxBeforeClose(DataSet: TDataset);
    procedure tmStatusTimer(Sender: TObject);
    procedure rgRetrModeClick(Sender: TObject);
    procedure btnWriteClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);

  private
    { Private-Deklarationen }
    procedure AppException(Sender: TObject; E: Exception);
    procedure ShowStatus(sMessage: String; lBeep: Boolean);

  public
    { Public-Deklarationen }
  end;

var
  fmMain: TfmMain;

implementation

{$R *.DFM}

procedure TfmMain.FormCreate(Sender: TObject);
begin
  pnlPropsEnable(false);
  Application.OnException := AppException;
  rgRetrMode.ItemIndex := ord(PxValRetriever.RetrieveMode); 
end;

procedure TfmMain.AppException(Sender: TObject; E: Exception);
begin
  showStatus(E.message, true);
end;

procedure TfmMain.ShowStatus(sMessage: String; lBeep: Boolean);
begin
  pnlStatus.Caption:=sMessage;
  if lBeep then
    MessageBeep (word(-1));

  tmStatus.Enabled := false;
  tmStatus.Enabled := true;
end;

procedure TfmMain.tmStatusTimer(Sender: TObject);
begin
  tmStatus.Enabled := false;
  pnlStatus.Caption:='';
end;

procedure TfmMain.pnlPropsEnable(YesNo: Boolean);
var
  i: Integer;
begin
  pnlProps.Enabled := YesNo;
  with pnlProps do
    for i:=0 to ControlCount-1 do
      if (not YesNo) or (Controls[i].Tag = 0) then
        Controls[i].Enabled := YesNo;
  btnWrite.Enabled := YesNo;
end;

procedure TfmMain.lsDirsChange(Sender: TObject);
begin
  db.close;
  db.Params.Values['PATH'] := lsDirs.Directory;
  db.open;
end;

procedure TfmMain.lsFilesChange(Sender: TObject);
begin
  if lsFiles.FileName <> '' then begin
    tblEdit.Close;
    tblEdit.TableName := lsFiles.FileName;
    tblEdit.Exclusive := True;
    try
      tblEdit.Open;
    except
      tblEdit.Exclusive := False;
      tblEdit.Open;
    end;
  end;
end;

procedure TfmMain.tblEditxAfterOpen(DataSet: TDataset);
var
  i: Integer;
begin
  lsFields.Items.Clear;
  with tblEdit do
    for i:=0 to FieldCount-1 do
      lsFields.Items.Add(Fields[i].FieldName);
  if (CompareText('.DB',ExtractFileExt(tblEdit.TableName))=0) then
    rgRetrMode.Enabled := True
  else
    rgRetrMode.ItemIndex := ord(retrCustomOnly);
  pnlPropsEnable(false);
  lsFields.ItemIndex := -1;
end;

procedure TfmMain.tblEditxBeforeClose(DataSet: TDataset);
begin
  lsFields.Items.Clear;
  pnlPropsEnable(false);
  rgRetrMode.Enabled := False;
end;

procedure TfmMain.lsFieldsClick(Sender: TObject);
var
  i: Integer;
  AFieldVchk: TPxFieldVchk;
begin
  pnlPropsEnable(true);
  i:=lsFields.ItemIndex;
  with tblEdit, AFieldVchk, lsFields do
    if (i >= 0) and (i < FieldCount) then begin
      showFieldType.ItemIndex := Ord(Fields[i].DataType);

      PxValRetriever.GetFieldValchecks(AFieldVchk,tblEdit,Items[i]);

      edHasValchecks.Checked := HasValchecks;
      edRequired.Checked := Required;
      edPicture.Text := Picture;
      edMinValue.Text := MinValue;
      edMaxValue.Text := MaxValue;
      edDefaultValue.Text := DefValue;
      btnClear.Enabled := HasValchecks;
    end;
end;


procedure TfmMain.rgRetrModeClick(Sender: TObject);
begin
  PxValRetriever.RetrieveMode := TPxRetrieveMode(rgRetrMode.ItemIndex);
  lsFieldsClick(Sender);
end;


procedure TfmMain.btnWriteClick(Sender: TObject);
begin
  PxValRetriever.SetCustomValchecks(tblEdit,
                                    lsFields.Items[lsFields.ItemIndex],
                                    edRequired.Checked,
                                    edMinValue.Text,
                                    edMaxValue.Text,
                                    edDefaultValue.Text,
                                    edPicture.Text);
  lsFieldsClick(Sender);
end;

procedure TfmMain.btnClearClick(Sender: TObject);
begin
  PxValRetriever.SetCustomValchecks(tblEdit,
                                    lsFields.Items[lsFields.ItemIndex],
                                    False,'','','','');
  lsFieldsClick(Sender);
end;

end.
