unit Pxdemo1;

{
 NOTE this is not really a demo on the basic features of PicEdits
 but on the special facilities of the TPxValcheckRetriever
 component!

 copy px_pdox.db + .val and px_dbase.dbf + .vch to your DBDEMOS
 alias (or change the Database settings of this project to point
 to these tables), compile, run and see...
 }

interface

{$V-,P+}

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
  {$IFDEF WIN32} PxConst2, PxEd2, PxDBEd2, PxDBGrd2, PxValRt2,
  {$ELSE}PxValRtr, PxEdit, PxDBEdit, PxDBGrid, PxConsts,{$ENDIF}
  DBTables, DB;


type
  TForm1 = class(TForm)
    DBPxPicGrid1: TDBPxPicGrid;
    DBPxPicEdit1: TDBPxPicEdit;
    DBPxPicEdit2: TDBPxPicEdit;
    DBPxPicEdit3: TDBPxPicEdit;
    PxValRetriever1: TPxValcheckRetriever;
    Table1: TTable;
    Query1: TQuery;
    DataSource1: TDataSource;
    rgControls: TRadioGroup;
    cbQueryCheck: TCheckBox;
    rgRetrMode: TRadioGroup;
    Bevel1: TBevel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    cbReq: TCheckBox;
    edMin: TEdit;
    edMax: TEdit;
    edDef: TEdit;
    edPic: TEdit;
    btnWrite: TButton;
    btnClear: TButton;
    Bevel2: TBevel;
    rgTableType: TRadioGroup;
    Label10: TLabel;
    edFieldName: TEdit;
    Database1: TDatabase;
    Label11: TLabel;
    Label12: TLabel;
    Bevel3: TBevel;
    Label13: TLabel;
    Label1: TLabel;
    procedure rgRetrModeClick(Sender: TObject);
    procedure rgTableTypeClick(Sender: TObject);
    procedure rgControlsClick(Sender: TObject);
    procedure cbQueryCheckClick(Sender: TObject);
    procedure DBPxPicGrid1ColEnter(Sender: TObject);
    procedure DBPxPicEditsEnter(Sender: TObject);
    procedure btnWriteClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PxValRetriever1BeforeRetrieve(Sender: TObject;
      var ADataset: TDBDataset; var AFieldName: TComponentName;
      var ARetrieveMode: TPxRetrieveMode);
    procedure DisplayValchecks(ADataset: TDBDataset;
                                  AFieldName: TComponentName);
    procedure DBPicEditsValidate(Sender: TObject; var ValText,
      ErrorMessage: TCaption; var FailType: TPxFailType; ValType: TPxValType);
    procedure PxValRetriever1AfterRetrieve(Sender: TObject;
      ADataset: TDBDataset; AFieldName: TComponentName;
      ARetrieveMode: TPxRetrieveMode; var AReqVal: Boolean; var AMinVal,
      AMaxVal, ADefVal, APicVal: TCaption);
    procedure DBPxPicGrid1FailValidate(Sender: TObject; ValText,
      ErrorMessage: string; FailType: TPxFailType; var CancelMessage,
      CancelError: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

const
  DemoTables: array[0..1] of TFileName
              = ('PX_PDOX.DB','PX_DBASE.DBF');

implementation

{$R *.DFM}

procedure TForm1.rgRetrModeClick(Sender: TObject);
var i:integer;
begin
  with PxValRetriever1 do
    RetrieveMode := TPxRetrieveMode(rgRetrMode.ItemIndex);
  ActiveControl := DBPxPicGrid1;
end;

procedure TForm1.rgTableTypeClick(Sender: TObject);
begin
  with rgTableType do
    if Table1.TableName <> DemoTables[ItemIndex] then
      rgControls.ItemIndex := 0;
  rgControlsClick(Sender);
end;

procedure TForm1.rgControlsClick(Sender: TObject);
begin
  {just very quick and dirty...}
  Table1.Close;
  Query1.Close;
  DataSource1.Dataset := nil;
  with rgTableType do
  begin
    Table1.TableName := DemoTables[ItemIndex];
    Query1.SQL.Clear;
    Query1.SQL.Add('SELECT * FROM "'+DemoTables[ItemIndex]+'"');
  end;
  if (rgControls.ItemIndex = 0) then
    DataSource1.Dataset := Table1
  else
    DataSource1.Dataset := Query1;
  cbQueryCheck.Enabled := (rgControls.ItemIndex = 1);
  (DataSource1.Dataset as TDBDataSet).Open;
  rgRetrModeClick(Sender);
end;


procedure TForm1.cbQueryCheckClick(Sender: TObject);
begin
  if cbQueryCheck.Checked then
  begin
    Table1.Open;
    PxValRetriever1.OnBeforeRetrieve := PxValRetriever1BeforeRetrieve;
  end
  else
    PxValRetriever1.OnBeforeRetrieve := nil;
  rgRetrModeClick(Sender);
end;


procedure Tform1.DisplayValchecks(ADataset: TDBDataset;
                                  AFieldName: TComponentName);
var FieldCheck: TPxFieldVchk;
begin
  edFieldName.Text := AFieldName;
  if PxValRetriever1.GetFieldValchecks(FieldCheck, ADataset,
                                       AFieldName) in [vresOk,vresHasNone] then
    DBPxPicEdit2.PicValidate;{updating single char display}
  with FieldCheck do
  begin
    cbReq.Checked := Required;
    edMin.Text := MinValue;
    edMax.Text := MaxValue;
    edDef.Text := DefValue;
    edPic.Text := Picture;
  end;
end;

procedure TForm1.DBPxPicGrid1ColEnter(Sender: TObject);
begin
  with (Sender as TDBPxPicGrid) do
    if (DataSource.Dataset as TDBDataset).Active then
    begin
      DisplayValchecks((DataSource.Dataset as TDBDataset),
                           SelectedField.FieldName);
      Invalidate;
    end;
end;


procedure TForm1.DBPxPicEditsEnter(Sender: TObject);
begin
  with (Sender as TDBPxPicEdit) do
    DisplayValchecks((DataSource.Dataset as TDBDataset), DataField);
end;


procedure TForm1.btnWriteClick(Sender: TObject);
begin
  PxValRetriever1.SetCustomValchecks(Table1,
                                   edFieldName.Text,
                                   cbReq.Checked,
                                   edMin.Text,
                                   edMax.Text,
                                   edDef.Text,
                                   edPic.Text);
  ActiveControl := DBPxPicGrid1;
end;


procedure TForm1.btnClearClick(Sender: TObject);
var td: TDateTime;
    ts: string;
begin
  PxValRetriever1.SetCustomValchecks(Table1, edFieldName.Text,
                                     False,'','','','');
  ActiveControl := DBPxPicGrid1;
end;


procedure TForm1.PxValRetriever1BeforeRetrieve(Sender: TObject;
  var ADataset: TDBDataset; var AFieldName: TComponentName;
  var ARetrieveMode: TPxRetrieveMode);
begin
  {this is all you have to do to re-direct
  the query to the table for valchecks...}
  if ADataset = Query1 then
    ADataset := Table1;
end;


procedure TForm1.PxValRetriever1AfterRetrieve(Sender: TObject;
  ADataset: TDBDataset; AFieldName: TComponentName;
  ARetrieveMode: TPxRetrieveMode; var AReqVal: Boolean; var AMinVal,
  AMaxVal, ADefVal, APicVal: TCaption);
begin
  {this is how you can use the retrEventOnly setting for coded
   settings. You can do calculations here, too, or read them from
   a custom file, or from a ressource file... no matter how you
   chose to do it, all PicEdit controls 'connected' to this event
   via a TPxValcheckRetriever will obey the same settings}
  if (ARetrieveMode = retrEventOnly)
  and (ADataset = Table1) then {to make the query checkbox work...}
  begin
    if UpperCase(AFieldName) = 'NUMERIC' then
    begin
      AMinVal := FloatToStr(123.5);
      AMaxVal := FloatToStr(234.6);
      AReqVal := True;
    end;
    if UpperCase(AFieldName) = 'ALPHA' then
      APicVal := '{B{lue,rown},Red}';
    if UpperCase(AFieldName) = 'ONE_CHAR' then
      APicVal := '{Lower,Raise,Balance}';
    if UpperCase(AFieldName) = 'DATE' then
      AMinVal := '%TODAY%+178';
  end;
end;

procedure TForm1.DBPicEditsValidate(Sender: TObject; var ValText,
  ErrorMessage: TCaption; var FailType: TPxFailType; ValType: TPxValType);
begin
  if FailType <> ftNone then
    DBPxPicGrid1.IndicatorColor := clRed
  else
    DBPxPicGrid1.IndicatorColor := clLime;
end;

procedure TForm1.DBPxPicGrid1FailValidate(Sender: TObject; ValText,
  ErrorMessage: string; FailType: TPxFailType; var CancelMessage,
  CancelError: Boolean);
begin
  {unlike other errors ftRetrieveErrors are triggered with
  CancelError set to True - here's an example for showing
  ftRetrieveErrors with the grid: }
  if (Sender = DBPxPicGrid1)
  and (FailType = ftRetrieveError) then
    CancelError := False;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  PxValRetriever1.RetrieveMode := TPxRetrieveMode(rgRetrMode.ItemIndex);
  try
    rgTableTypeClick(self); {open default table}
  except
    Showmessage('Could not open tables - program halted');
    Halt(1);
  end;
end;


end.



